#!/bin/sh

apt-get -y --force-yes purge slapd ldap-utils gnutls-bin libnss-ldap samba samba-doc smbldap-tools
rm -rf /etc/ldap
rm -rf /etc/samba
rm -rf /etc/smbldap-tools
rm -rf /var/lib/ldap
rm -rf /var/lib/libnss-ldap
rm -rf /var/lib/samba
rm -rf /var/cache/samba
rm -rf /var/backups/*

adduser admin << EOF
xbcn.kz
xbcn.kz





y
EOF

#rm -rf gosa-combined-2.7.4
#rm gosa-combined-2.7.4.tar.gz
#wget http://oss.gonicus.de/pub/gosa/gosa-combined-2.7.4.tar.gz
tar -xf gosa-combined-2.7.4.tar.gz

apt-get -y --force-yes install slapd ldap-utils gnutls-bin

ldapadd -Y EXTERNAL -H ldapi:/// -f /etc/ldap/schema/cosine.ldif
ldapadd -Y EXTERNAL -H ldapi:/// -f /etc/ldap/schema/nis.ldif
ldapadd -Y EXTERNAL -H ldapi:/// -f /etc/ldap/schema/inetorgperson.ldif
ldapadd -Y EXTERNAL -H ldapi:/// -f /etc/ldap/schema/openldap.ldif
ldapadd -Y EXTERNAL -H ldapi:/// -f /etc/ldap/schema/misc.ldif

cp gosa-combined-2.7.4/contrib/openldap/*.ldif     /etc/ldap/schema
cp gosa-combined-2.7.4/contrib/plugins/dns/*.ldif  /etc/ldap/schema
cp gosa-combined-2.7.4/contrib/plugins/dhcp/*.ldif /etc/ldap/schema
ldapadd -Y EXTERNAL -H ldapi:/// -f /etc/ldap/schema/trust.ldif
ldapadd -Y EXTERNAL -H ldapi:/// -f /etc/ldap/schema/samba3.ldif
ldapadd -Y EXTERNAL -H ldapi:/// -f /etc/ldap/schema/gosystem.ldif 
ldapadd -Y EXTERNAL -H ldapi:/// -f /etc/ldap/schema/gofon.ldif
ldapadd -Y EXTERNAL -H ldapi:/// -f /etc/ldap/schema/goto.ldif
ldapadd -Y EXTERNAL -H ldapi:/// -f /etc/ldap/schema/goto-mime.ldif
ldapadd -Y EXTERNAL -H ldapi:/// -f /etc/ldap/schema/gosa-samba3.ldif
ldapadd -Y EXTERNAL -H ldapi:/// -f /etc/ldap/schema/gofax.ldif
ldapadd -Y EXTERNAL -H ldapi:/// -f /etc/ldap/schema/goserver.ldif
ldapadd -Y EXTERNAL -H ldapi:/// -f /etc/ldap/schema/dnszone.ldif
ldapadd -Y EXTERNAL -H ldapi:/// -f /etc/ldap/schema/dhcp.ldif

sh -c "certtool --generate-privkey > /etc/ssl/private/cakey.pem"
cat << EOF > /etc/ssl/ca.info
cn = LYCEUM
ca
cert_signing_key
EOF

certtool --generate-self-signed --load-privkey /etc/ssl/private/cakey.pem --template  /etc/ssl/ca.info --outfile /etc/ssl/certs/cacert.pem
sh -c "certtool --generate-privkey > /etc/ssl/private/pdc_slapd_key.pem"
cat << EOF > /etc/ssl/pdc.info
organization = LYCEUM
cn = pdc.lyceum.ru
tls_www_server
encryption_key
signing_key
EOF

certtool --generate-certificate --load-privkey /etc/ssl/private/pdc_slapd_key.pem --load-ca-certificate /etc/ssl/certs/cacert.pem --load-ca-privkey /etc/ssl/private/cakey.pem --template /etc/ssl/pdc.info --outfile /etc/ssl/certs/pdc_slapd_cert.pem

ldapmodify -Y EXTERNAL -H ldapi:/// -f cert.ldif
ldapmodify -Y EXTERNAL -H ldapi:/// -f samba_indexes.ldif
ldapmodify -Y EXTERNAL -H ldapi:/// -f gosa_indexes.ldif

chmod 755 /etc/ssl/private

/etc/init.d/slapd restart
slaptest

echo "Path 2"
apt-get -y --force-yes install libnss-ldap
cp ldap.conf   /etc
cp ldap.secret /etc
auth-client-config -t nss -p lac_ldap
pam-auth-update



echo "Path 3"
apt-get -y --force-yes install samba samba-doc smbldap-tools
#wget http://download.gna.org/smbldap-tools/sources/0.9.3/smbldap-tools-0.9.3.tar.gz

cp smbldap_tools.pm.patched /usr/share/perl5/smbldap_tools.pm
cp smbldap-useradd.patched  /usr/sbin/smbldap-useradd

cp smbldap.conf      /etc/smbldap-tools
cp smbldap_bind.conf /etc/smbldap-tools

cp slapd /etc/default
/etc/init.d/slapd restart

net setlocalsid S-1-5-21-4255227115-3253002463-444595296

ldapadd -x -D cn=admin,dc=lyceum,dc=ru -W -f sambadb.ldif

smbldap-passwd -a admin << EOF
xbcn.kz
xbcn.kz
EOF

smbldap-useradd -a -P client << EOF
client
client
EOF

rm -rf gosa-combined-2.7.4
echo "========================================"
echo "First path of instaletion was complited"
echo "Please, restart computer"
echo "After start. exec pdc2.x"


